package in.techware.carrefour.dbUtils.dao;

import android.arch.persistence.room.Dao;
import android.arch.persistence.room.Delete;
import android.arch.persistence.room.Insert;
import android.arch.persistence.room.OnConflictStrategy;
import android.arch.persistence.room.Query;
import android.arch.persistence.room.Update;

import java.util.List;

import in.techware.carrefour.dbUtils.entity.InternalSalesEntity;


/**
 * Created by Jemsheer K D on 25 July, 2018.
 * Package in.techware.carrefour.dbUtils.dao
 * Project Carrefour
 */

@Dao
public interface InternalSalesDao {

    @Query("SELECT * FROM internalSales")
    List<InternalSalesEntity> loadAllInternalSales();

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    void insertAll(List<InternalSalesEntity> internalSalesEntityList);


    @Query("select * from internalSales where id = :id ORDER BY id DESC LIMIT 1")
    List<InternalSalesEntity> getInternalSales(String id);

    @Query("select * from internalSales where sendStatus = 0 ORDER BY id")
    List<InternalSalesEntity> getAllUnsentInternalSales();

    @Query("select * from internalSales where sendStatus = 1 ORDER BY id")
    List<InternalSalesEntity> getAllSentInternalSales();

    @Query("DELETE from internalSales where sendStatus = 0")
    void deleteAllUnsentInternalSales();

    @Query("DELETE from internalSales where sendStatus = 1")
    void deleteAllSentInternalSales();

    @Query("DELETE FROM internalSales")
    void deleteAll();

    @Insert
    long insert(InternalSalesEntity internalSalesEntity);

    @Update
    void update(InternalSalesEntity internalSalesEntity);

    @Delete
    void delete(InternalSalesEntity internalSalesEntity);
}
